unit AmpelU;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, Buttons, StdCtrls;

type
  // Typ, welcher die möglichen Ampelstellungen definiert
  TAmpelstatus = (asRot, asRotGelb, asGruen, asGelb);

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    rbRot: TRadioButton;
    rbRotGelb: TRadioButton;
    rbGruen: TRadioButton;
    rbGelb: TRadioButton;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure radiobuttonClicked(Sender: TObject);
  private
    { private declarations }
    fUpdating : boolean;
    fAmpelstatus : TAmpelstatus;
    procedure SetAmpelstatus(Value : TAmpelstatus);
  public
    { public declarations }
    property  Ampelstatus : TAmpelstatus read fAmpelstatus write SetAmpelstatus;
    procedure NextStatus; // Schaltet in den nächsten Zustand
  end;

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if (Shape1.Brush.Color = clWhite) and (Shape2.Brush.Color = clWhite) and (Shape3.Brush.Color = clWhite) then
   Shape1.Brush.Color := clRed
  else if (Shape1.Brush.Color = clRed) and (Shape2.Brush.Color = clWhite) then
   Shape2.Brush.Color := clYellow
  else if (Shape1.Brush.Color = clRed) and (Shape2.Brush.Color = clYellow) then
  begin
   Shape1.Brush.Color := clWhite;
   Shape2.Brush.Color := clWhite;
   Shape3.Brush.Color := clLime;
  end else if (Shape3.Brush.Color = clLime) then
  begin
   Shape3.Brush.Color := clWhite;
   Shape2.Brush.Color := clYellow;
  end else
  begin
   Shape1.Brush.Color := clRed;
   Shape2.Brush.Color := clWhite;
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 NextStatus;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  fUpdating := True;
  Ampelstatus := asRot;
  fUpdating := False;
end;

procedure TForm1.radiobuttonClicked(Sender: TObject);
begin
  if fUpdating then exit;
  fUpdating := true;
  try
   if Sender = rbRot then Ampelstatus := asRot else
   if Sender = rbRotGelb then Ampelstatus := asRotGelb else
   if Sender = rbGruen then Ampelstatus := asGruen else
   if Sender = rbGelb then Ampelstatus := asGelb else
    raise Exception.Create('unbekannter Sender in TForm1.RadiobuttonChanged');
  finally
   fUpdating := false;
  end;
end;


procedure TForm1.SetAmpelstatus(Value: TAmpelstatus);
begin
  fAmpelstatus := Value;
  Shape1.Brush.Color := clWhite;
  Shape2.Brush.Color := clWhite;
  Shape3.Brush.Color := clWhite;
  case fAmpelstatus of
   asRot     : begin
                Shape1.Brush.Color := clRed;
                rbRot.Checked := True;
               end;
   asRotGelb : begin
                Shape1.Brush.Color := clRed;
                Shape2.Brush.Color := clYellow;
                rbRotGelb.Checked := True;
               end;
   asGelb    : begin
                 Shape2.Brush.Color := clYellow;
                 rbGelb.Checked := True;
               end;
   asGruen   : begin
                 Shape3.Brush.Color := clLime;
                 rbGruen.Checked := True;
               end;
  end;
end;

procedure TForm1.NextStatus;
begin
  fUpdating := True;
  try
    case Ampelstatus of
     asRot     : Ampelstatus := asRotGelb;
     asRotGelb : Ampelstatus := asGruen;
     asGruen   : Ampelstatus := asGelb;
     asGelb    : Ampelstatus := asRot;
    end;
  finally
    fUpdating := False;
  end;
end;

initialization
  {$I ampelu.lrs}

end.

